import requests
import sys, os


def sort_snapshots_by_end_time(e):
    return e['end_time_in_millis']


if len(sys.argv) < 2:
    print("Could not retrieve snapshots. Please contact administrator")
    sys.exit(1)

else:
    repo_name = sys.argv[1]
    snapshots_offset = 10
    print("Retrieving last {} snapshots from {} repository".format(str(snapshots_offset), repo_name))
    try:
        r = requests.get('http://localhost:9200/_snapshot/{}/_all?ignore_unavailable=true'.format(repo_name))
        if r.status_code == 200:
            snapshots_json = r.json()
            if 'snapshots' in snapshots_json.keys():
                snapshots = snapshots_json["snapshots"]
                snapshots.sort(reverse=True, key=sort_snapshots_by_end_time)
                success_snapshots = list(filter(lambda snapshot: snapshot['state'] == 'SUCCESS', snapshots))
                fitered_snapshots = list(map(lambda snap: snap['snapshot'], success_snapshots))[:snapshots_offset]
                print(str(fitered_snapshots))
            else:
                print("Could not retrieve snapshots. Please contact administrator")
                sys.exit(1)
        else:
            print("Could not retrieve snapshots. Respnse status code was {} instead 200. Please contact administrator".format(r.status_code))
            sys.exit(1)
    except Exception as es:
        print("Could not retrieve snapshots. {}".format(str(es)))
        sys.exit(1)