if [ "$1" = "" ]; then
    echo 'ERROR: No url as first argument'
    exit 
fi;

env=${2:-linux}

if [ "$env" = "mac" ]; then
    echo 'MAC OS'
    localUrl=$(ipconfig getifaddr en0)
else 
    echo 'LINUX OS'
    localUrl=$(hostname -i)
fi;

echo '1_Logging in user\n'
token=$(curl -H "Content-Type: application/json" -X POST -d '{"email":"admin@bpcs.com","password":"BDE_great!23"}' $1/auth | jq '.jwtToken' -r)
echo '\n'

echo '2_Creating Blob Storage connector\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d '
{"name":"blob_trial","namespace":"default","database":"test","connectionUrl":"wasbs://test@conduitstorage.blob.core.windows.net","connectionUsername":"conduitstorage","connectionPassword":"TjWXdPBOfYYLFyVf+7rqoyWin8m6oKJK9OKgaRg0PjMo54aYSgfjwYTIjw4j4KY3CUp4QLE253Eg/s59T2eUFA==","description":"This is an Azure Blob Storage trial connector","typeName":"file","tableNames":["1M.csv","folder1","titanic_json"],"authenticationType":"anonymous_with_impersonation","cluster":"local","tablesSchema":{},"tablesCache":{},"tablesEagerCache":{},"tablesAlias":{"1M.csv":"alias_1","folder1":"alias_2","titanic_json":"alias_3"},"tablesDescription":{},"tablesTags":{},"userSubscription":"","serviceSubscription":"","isAuthorizationEnabled":false,"enableCache":false,"shouldUpdateTree":false,"tablesFirstRowHeader":{"1M.csv":false,"folder1":false,"titanic_json":false},"tablesFileType":{"1M.csv":"csv","folder1":"csv","titanic_json":"json"},"tablesPaths":{"1M.csv":["1M.csv"],"folder1":["folder1"],"titanic_json":["titanic_json"]},"isHivePartitioningFolder":{"1M.csv":false,"folder1":false,"titanic_json":false},"isDynamicFolder":{"1M.csv":false,"folder1":false,"titanic_json":false},"fileUrlPrefix":"wasbs://","databaseExtractionRegex":{},"displayName":"Azure Blob Storage","notHiveDynamicTable":["1M.csv"],"adSubscriptions":{},"dataSourceConnection":{"database":"test","connectionUrl":"wasbs://test@conduitstorage.blob.core.windows.net","connectionUsername":"conduitstorage","connectionPassword":"VGpXWGRQQk9mWVlMRnlWZis3cnFveVdpbjhtNm9LSks5T0tnYVJnMFBqTW81NGFZU2dmandZVElqdzRqNEtZM0NVcDRRTEUyNTNFZy9zNTlUMmVVRkE9PQ=="},"specificColumns":{"tablesFileType":{"1M.csv":"csv","folder1":"csv","titanic_json":"json"},"tablesFirstRowHeader":{"1M.csv":false,"folder1":false,"titanic_json":false},"tablesPaths":{"1M.csv":["1M.csv"],"folder1":["folder1"],"titanic_json":["titanic_json"]},"isHivePartitioningFolder":{"1M.csv":false,"folder1":false,"titanic_json":false},"isDynamicFolder":{"1M.csv":false,"folder1":false,"titanic_json":false}},"fetchSize":{},"partitionSize":{},"queryTimeout":{}}
' $1/api/metadata/datasources
echo '\n'

echo '3_Creating Elasticsearch connector\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d "
{\"name\":\"es_trial\",\"namespace\":\"default\",\"database\":\"es_trial\",\"connectionUrl\":\"$localUrl:9200\",\"connectionUsername\":\"\",\"connectionPassword\":\"\",\"description\":\"This is an Elasticsearch trial connector\",\"typeName\":\"es\",\"tableNames\":[\"bde_group___default\",\"bde_license___default\",\"bde_user___default\"],\"authenticationType\":\"anonymous_with_impersonation\",\"cluster\":\"\",\"tablesSchema\":{},\"tablesCache\":{},\"tablesEagerCache\":{},\"tablesAlias\":{\"bde_license___default\":\"alias_1\"},\"tablesDescription\":{},\"tablesTags\":{},\"userSubscription\":\"\",\"serviceSubscription\":\"\",\"isAuthorizationEnabled\":false,\"enableCache\":false,\"shouldUpdateTree\":false,\"fetchSize\":{\"bde_license___default\":10000},\"partitionSize\":{\"bde_license___default\":100000},\"queryTimeout\":{\"bde_license___default\":30},\"authenticationRadios\":[{\"realValue\":\"anonymous_with_impersonation\",\"displayValue\":\"Anonymous with Impersonation\"},{\"realValue\":\"basic_with_impersonation\",\"displayValue\":\"Conduit Authentication with Impersonation\"},{\"realValue\":\"active_directory_with_impersonation\",\"displayValue\":\"Active Directory with Impersonation\"},{\"realValue\":\"basic_pass_through\",\"displayValue\":\"User Credentials Pass Through\"}],\"displayName\":\"Elasticsearch\",\"adSubscriptions\":{},\"dataSourceConnection\":{\"database\":\"es_trial\",\"connectionUrl\":\"$localUrl:9200\",\"connectionUsername\":\"\"},\"specificColumns\":{\"partitionColumn\":{},\"partitionCount\":{}}}
" $1/api/metadata/datasources

echo '4_Creating Odata connector\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d '
{"name":"odata_trial","namespace":"default","database":"odata_trial","connectionUrl":"https://services.odata.org/V4/Northwind/Northwind.svc","connectionUsername":"","connectionPassword":"","description":"This is an Odata trial connector","typeName":"odata","tableNames":["Employees","Orders","Products","Shippers"],"authenticationType":"basic_with_impersonation","cluster":"","tablesSchema":{},"tablesCache":{"Employees":"30m","Orders":"1h","Products":"2h","Shippers":"3h"},"tablesEagerCache":{"Employees":false,"Orders":false,"Products":false,"Shippers":false},"tablesAlias":{"Employees":"alias_employees","Orders":"alias_orders","Products":"alias_products","Shippers":"alias_shippers"},"tablesDescription":{},"tablesTags":{},"userSubscription":"","serviceSubscription":"","isAuthorizationEnabled":false,"enableCache":true,"shouldUpdateTree":false,"authenticationRadios":[{"realValue":"anonymous_with_impersonation","displayValue":"Anonymous with Impersonation"},{"realValue":"basic_with_impersonation","displayValue":"Conduit Authentication with Impersonation"},{"realValue":"active_directory_with_impersonation","displayValue":"Active Directory with Impersonation"},{"realValue":"basic_pass_through","displayValue":"User Credentials Pass Through"}],"displayName":"OData","databaseValue":{"value":true,"validators":[]},"adSubscriptions":{},"dataSourceConnection":{"database":"odata_trial","connectionUrl":"https://services.odata.org/V4/Northwind/Northwind.svc","connectionUsername":""},"specificColumns":{"partitionColumn":{"Employees":"EmployeeID","Orders":"EmployeeID","Products":"CategoryID","Shippers":""},"partitionCount":{"Employees":4,"Orders":4,"Products":4,"Shippers":4},"partitionColumnsList":{"Products":["CategoryID","ProductID","ReorderLevel","SupplierID","UnitsInStock","UnitsOnOrder"],"Orders":["EmployeeID","OrderID","ShipVia"],"Shippers":["ShipperID"],"Employees":["EmployeeID","ReportsTo"]}},"fetchSize":{},"partitionSize":{},"queryTimeout":{}}
' $1/api/metadata/datasources
echo '\n'

echo '5_Creating AWS S3 connector\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d '
{"name":"s3_trial","namespace":"default","database":"conduittest","connectionUrl":"s3a://conduittest","connectionUsername":"AKIASGY3ZDTSPNVRLEOH","connectionPassword":"uDQZwrwT2IcACAIKdThA1Ek8HqLtVELml6h948JV","description":"This is an AWS S3 trial connector.","typeName":"awss3","tableNames":["1M.csv","all_types.csv","books_json"],"authenticationType":"anonymous_with_impersonation","cluster":"local","tablesSchema":{},"tablesCache":{},"tablesEagerCache":{},"tablesAlias":{"1M.csv":"alias_1m","all_types.csv":"alias_alltypes","books_json":"alias_books_json"},"tablesDescription":{},"tablesTags":{},"userSubscription":"","serviceSubscription":"","isAuthorizationEnabled":false,"enableCache":false,"shouldUpdateTree":false,"tablesFirstRowHeader":{"1M.csv":false,"all_types.csv":true,"books_json":false},"tablesFileType":{"1M.csv":"csv","all_types.csv":"csv","books_json":"json"},"tablesPaths":{"1M.csv":["1M.csv"],"all_types.csv":["all_types.csv"],"books_json":["books/books_json"]},"isHivePartitioningFolder":{"1M.csv":false,"all_types.csv":false,"books_json":false},"isDynamicFolder":{"1M.csv":false,"all_types.csv":false,"books_json":false},"fileUrlPrefix":"s3a://","databaseExtractionRegex":{},"displayName":"AWS S3","awsRegion":"us-east-2","notHiveDynamicTable":["1M.csv","all_types.csv"],"adSubscriptions":{},"dataSourceConnection":{"database":"conduittest","connectionUrl":"s3a://conduittest","connectionUsername":"AKIASGY3ZDTSPNVRLEOH","connectionPassword":"dURRWndyd1QySWNBQ0FJS2RUaEExRWs4SHFMdFZFTG1sNmg5NDhKVg=="},"specificColumns":{"tablesFileType":{"1M.csv":"csv","all_types.csv":"csv","books_json":"json"},"tablesFirstRowHeader":{"1M.csv":false,"all_types.csv":true,"books_json":false},"tablesPaths":{"1M.csv":["1M.csv"],"all_types.csv":["all_types.csv"],"books_json":["books/books_json"]},"isHivePartitioningFolder":{"1M.csv":false,"all_types.csv":false,"books_json":false},"isDynamicFolder":{"1M.csv":false,"all_types.csv":false,"books_json":false},"awsRegion":"us-east-2"},"fetchSize":{},"partitionSize":{},"queryTimeout":{}}
' $1/api/metadata/datasources
echo '\n'

echo '6_Creating Postgres connector\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d "
{\"name\":\"postgres_trial\",\"namespace\":\"default\",\"database\":\"sample\",\"connectionUrl\":\"$localUrl:9200\",\"connectionUsername\":\"postgres\",\"connectionPassword\":\"BDE_great!23\",\"description\":\"This is a Postgres trial connector\",\"typeName\":\"postgresql\",\"tableNames\":[\"public___books\",\"public___data_types\",\"public___petrodata\"],\"authenticationType\":\"anonymous_with_impersonation\",\"cluster\":\"\",\"tablesSchema\":{},\"tablesCache\":{},\"tablesEagerCache\":{},\"tablesAlias\":{\"public___books\":\"alias_books\",\"public___data_types\":\"alias_data_types\",\"public___petrodata\":\"alias_petrodata\"},\"tablesDescription\":{},\"tablesTags\":{},\"userSubscription\":\"\",\"serviceSubscription\":\"\",\"isAuthorizationEnabled\":false,\"enableCache\":false,\"shouldUpdateTree\":false,\"authenticationRadios\":[{\"realValue\":\"anonymous_with_impersonation\",\"displayValue\":\"Anonymous with Impersonation\"},{\"realValue\":\"basic_with_impersonation\",\"displayValue\":\"Conduit Authentication with Impersonation\"},{\"realValue\":\"active_directory_with_impersonation\",\"displayValue\":\"Active Directory with Impersonation\"},{\"realValue\":\"basic_pass_through\",\"displayValue\":\"User Credentials Pass Through\"}],\"displayName\":\"PostgreSQL\",\"databaseValue\":{\"value\":true,\"validators\":[]},\"adSubscriptions\":{},\"dataSourceConnection\":{\"database\":\"sample\",\"connectionUrl\":\"$localUrl:5432\",\"connectionUsername\":\"postgres\",\"connectionPassword\":\"QkRFX2dyZWF0ITIz\"},\"specificColumns\":{\"partitionColumn\":{\"public___books\":\"Year-Of-Publication\",\"public___data_types\":\"bigint\",\"public___petrodata\":\"COWCODE\"},\"partitionCount\":{\"public___books\":4,\"public___data_types\":4,\"public___petrodata\":4},\"partitionColumnsList\":{\"public___books\":[\"Year-Of-Publication\"],\"public___data_types\":[\"bigint\",\"smallint\",\"int\",\"serial\",\"float\",\"real\",\"numeric\"],\"public___petrodata\":[\"COWCODE\",\"CONTCODE\",\"SITENUM\",\"FIELDINFO\",\"DISC\",\"DISCPRES\",\"PROD\",\"PRODPRES\"]}},\"fetchSize\":{},\"partitionSize\":{},\"queryTimeout\":{}}
" $1/api/metadata/datasources
echo '\n'

echo '7_Getting all users'
users=$(curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X GET $1/api/users | jq '.[].email') 
users=$(echo $users | tr ' ' ',')

echo '8_Creating Free Trial group\n'
curl -H "Content-Type: application/json" -H "Authorization: Bearer $token" -X POST -d "
{\"name\":\"Free Trial\",\"groupType\":\"internal\",\"description\":\"This is a group\",\"subscriptionName\":\"\",\"members\":[$users],\"accessRights\":[{\"connectorName\":\"blob_trial\",\"databaseName\":\"test\",\"tableNames\":[\"1M.csv\",\"folder1\"]},{\"connectorName\":\"postgres_trial\",\"databaseName\":\"sample\",\"tableNames\":[\"public___books\",\"public___data_types\"]},{\"connectorName\":\"es_trial\",\"databaseName\":\"es_blob\",\"tableNames\":[\"bde_license___default\"]},{\"connectorName\":\"odata_trial\",\"databaseName\":\"odata_trial\",\"tableNames\":[\"Employees\",\"Orders\"]},{\"connectorName\":\"s3_trial\",\"databaseName\":\"conduittest\",\"tableNames\":[\"1M.csv\",\"all_types.csv\",\"books_json\"]}],\"securityEnabled\":\"true\"}
" $1/api/groups
echo '\n'
